{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P+,Q-,R-,S-,T-,V-,X+,Y+}
{$M 8000,10000,50000}
Program UMBTest;

Uses HeapUMB, dos, crt;

const hex     : array[0..15] of char = '0123456789ABCDEF';
{ͻ
  Umb Test     Renvoie la valeur hexa d'un pointeur                      
 Ķ
  La chaine de sortie est au format SSSS:OOOO                             
 ͼ}
Function  PHexa (n : pointer) : string;
var i  : byte;
    s  : string[9];
begin
  s[0] := #8;
  for i := 1 to 8 do begin
    s[9-i] := hex[longint(n) AND 15];
    longint(n) := longint(n) shr 4;
  end;
  insert (':', s, 5);
  Phexa := s;
end;

{ͻ
  Umb Test     Renvoie la correspondance hexa d'un nombre                
 Ķ
  La chaine de la sortie est ajust au nombre de chiffres du nombre.      
 ͼ}
Function  Hexa (n : word) : string;
var i  : byte;
    s  : string[4];
begin
  s[0] := #4;
  for i := 4 downto 1 do begin
    s[i] := hex[n AND 15];
    n := n shr 4;
  end;
  hexa := s;
end;

{ͻ
  Umb Test     Met des infos relatives aux UMBs initialiss dans UMB.INF 
 Ķ
  Ouvre le fichier, le referme.                                           
 ͼ}
Procedure GetInfo;
var bloc1, bloc2 : blocptr;
    free1, free2 : freeptr;
    HeapSize     : longint;
    out          : text;
Begin
  Assign (Out, 'UMB.INF');
  Rewrite(out);

  Writeln (out, '             Exemple de programme utilisant l''unit UMB');
  Writeln (out, '            =============================================');
  Writeln (out);
  Writeln (out, 'Informations sur le succs de la gestion UMB :');
  Writeln (out, '');
  Writeln (out);

  IF NbUmb>0 then begin
    Writeln (out, ' ', NbUmb, ' UMB(s) gr(s)');
    Writeln (out);

    Writeln (out, ' Parcours des UMBs : ');
    Bloc1 := fBloc;
    While Bloc1 <> NIL do with Bloc1^ do begin
      Writeln (out, '  Position : ', Hexa(segm), ', taille = ', longint(size)*16 );
      Bloc1 := next;
    end;

    Writeln (out);
    Writeln (out, ' Parcours des blocs Libres Pascal : ');
    Free1 := FreeList;
    While Free1 <> HeapPtr do with Free1^ do begin
      Writeln (out, '  Position : ', pHexa(Free1),
               ', taille = ', longint(sizeS)*16+SizeO,
               ', prochain = ', pHexa(next));
      free1 := next;
    end;
    Writeln (out, '  Position : ', pHexa(HeapPtr),
             ', taille = ', (Seg(HeapEnd^)-Seg(HeapPtr^)) SHL 4 -
                            Ofs(HeapPtr^));

    HeapSize := longint(Seg(HeapEnd^)-Seg(HeapOrg^)) SHL 4 + Ofs(HeapOrg^);
    Writeln (out);
    Writeln (out, '  Taille normale du tas      = ', HeapSize);
    Writeln (out, '+ Taille ajoute par les UMB = ', Umbsize);
    Writeln (out, '= Taille totale du tas       = ', HeapSize+UmbSize);
    Writeln (out);
    Writeln (out, ' Informations mmoire libre :');
    Writeln (out, '  Taille totale libre du tas = ', MemAvail);
    Writeln (out, '  Taille maxi libre du tas   = ', MaxAvail);

  end else begin
    Writeln (out, 'Les UMBs ne sont pas grs. Causes possibles :');
    Writeln (out, '   - Dos < 5');
    Writeln (out, '   - commande DOS=UMB manquante dans CONFIG.SYS');
    Writeln (out, '   - plus d''espace dans les UMBs');
    Writeln (out, '   - HIMEM.SYS non charg');
    Writeln (out, '   - votre PC ne dispose que de 640 KO de mmoire');
  end;
  Close (Out);
end;

{ͻ
  Umb Test     Lit le fichier UMB.INF                                    
 Ķ
  Le passe en mmoire.                                                    
 ͼ}
Type  LinePtr = ^LineRec;
      LineRec = record
        next : LinePtr;
        pred : LinePtr;
        size : byte;
      end;
      str = string;
Var   Fline : LinePtr;

Procedure Load;
var f            : text;
    line1, line2 : linePtr;
    s            : string;
Begin
  Assign (f, 'UMB.INF');
  Reset (f);
  Fline := NIL;
  Line2 := NIL;
  While not eof(f) do begin
    Readln (f, s);
    GetMem (line1, sizeof(LineRec)+length(s));
    If Fline = NIL
      then Fline := line1
      else Line2^.next := line1;
    With Line1^ do begin
      next := NIL;
      pred := Line2;
      Move (s, Size, length(s)+1);
      Line2 := Line1;
      Line1 := next;
    end;
  end;
  Close (f);
end;

{ͻ
  Umb Test     Affiche le fichier UMB.INF                                
 Ķ
  Permet de scroller                                                      
 ͼ}
Procedure View;
const spaces70 : string = '                                                                      ';
var aline, line1, line2 : lineptr;
    i            : word;
    s : string;
Begin
  aline := fline;
  line2 := NIL;
  textattr := 7*16;
  ClrScr;
  TextAttr := 5*16+14;
  Write (Copy(' F1 = DOS   Scroll  ESC quitter  '+Spaces70, 1, 80));
  Repeat

    TextAttr := 30;
    if line2 <> aline then begin
      line1 := aline;
      line2 := aline;
      For i := 3 to 24 do
        if line1 <> NIL then with line1^ do begin
          GotoXy (5, i);
          Write ( copy(str(Ptr(seg(size), ofs(size))^) + Spaces70, 1, 70) );
          line1 := next;
        end;
    end;

    Case readkey of
      #27 : break;
      #0  : case readkey of
              #59 : begin
                      textattr := 15;
                      ClrScr;
                      Swapvectors;
                      Exec (GetEnv('COMSPEC'), '/KMEM /D|MORE');
                      SwapVectors;
                      Break;
                    end;
              #72 : if aline^.pred <> NIL then aline := aline^.pred;
              #80 : if line1 <> NIL then aline := aline^.next;
            end;
    end;

  Until false;
  textattr := 15;
  ClrScr;
end;

BEGIN

  GetInfo;
  Load;
  View;

END.