;    Initialisation du mode FLAT
; par * Warrant * pour le Reporter 9

.386p

code segment 'code' use16
	assume cs:code,ds:code
	push cs
	pop ds


	push cs
	pop ss
        lea sp,pile+256 ;une pile de 256 octets, a devrait suffire.
	
	mov ax,es	;ES pointe sur le PSP
	mov bx,ss
	sub bx,ax	;intervalle entre PSP et pile (en paras)
	mov ax,sp
	add ax,15	;Tient compte d'un ventuel dernier paragraphe
	shr ax,4	;transforme en paragraphes
	add bx,ax	;taille totale
	mov ah,4ah
        int 21h         ;ajuste la mmoire
	
	mov ax,4300h
	int 2fh
	cmp al,80h	;XMS prsent ?
	je xms_ok
	mov ah,09
	lea dx,no_xms
	int 21h
	jmp fin

xms_ok:	mov ax,4310h
	int 2fh	;sortie ES:BX
	mov word ptr [xms_addy+2],es
	mov word ptr [xms_addy],bx
	
	mov eax,cr0	;teste si le CPU est en mode v86
	and eax,1
	jz lets_flat
        mov ah,09       ;Hlas, le CPU est en v86 !
	lea dx,v86
	int 21h
	jmp fin

lets_flat: 	cli
	mov eax,cs	;dbut conversion en adresse relle
	shl eax,4
	mov ebx,offset gdt
	add eax,ebx	;EAX = addy linaire de la GDT.
	mov dword ptr [gdt_struct+2],eax

	lea bx,gdt_struct        ;Nbr valeurs dans GDT
	LGDT [BX]

	mov eax,cr0
	or eax,1	
	mov cr0,eax	;PE enable
	jmp $+2	;vide prefetch
	
        mov bx,8        ;on se place sur le 2me slecteur (1er=null)
	mov ds,bx
	mov es,bx
	mov fs,bx
	mov gs,bx	;Yahou, maintenant 4Gigas dispos !
	
	and al,0feh	;"AL" contient toujours le MSW (cr0)
	mov cr0,eax	;repasse en mode rel
        jmp $+2         ;pas indispensable ?
	sti

Get_EMB: mov ah,09      ;demande un bloc
	mov dx,1000	;taille en KO ! (64 Mo maxi, huhuh!)
	call dword ptr [cs:xms_addy]	;Gosh!
	or ax,ax
	jnz EMB_ok
	
	mov ah,09	;a n'a pas march
	push cs
        pop ds          ;moyen le plus simple d'utiliser les INTs
	lea dx,no_more_xms
	int 21h
	jmp fin 

EMB_ok:	mov [cs:handle_emb],dx
        mov ah,0ch      ;verrouiller EMB (DX est okay, cf. ci-dessus)
	call dword ptr [cs:xms_addy]	;Sortie: DX:BX addy linaire EMB
	mov word ptr [chunk_addy+2],DX
	mov word ptr [chunk_addy],BX


TST:       mov edi,0b8000h-128  ;addy seg. texte 32 bits
           mov cx,messy_length
           lea edx,[cs:messy]
           mov ah,17h           ;attribut des caractres
     @tst: mov al,byte ptr [cs:edx]
           mov word ptr [edi],ax
           add edi,2            ;caractre suivant (passe attribut)
           inc dx
           loop @tst

        esc_w: in al,60h
               dec al
               jnz esc_w


;A partir d'ici, on se prpare  sortir en abandonnant lchement la mmoire.

Free_EMB:	mov ah,0dh	;Unlock EMB
        mov dx,[cs:handle_emb]  ;DX va servir 2 fois (fx 0dh & 0ah)
	call dword ptr [cs:xms_addy]
        mov ah,0ah              ;librer EMB (DX contient dja le handle)
	call dword ptr [cs:xms_addy]

fin:	mov ax,4c00h
	int 21h


gdt equ this WORD                         ;deux slecteurs
               dw 0,0,0,0
               dw 0ffffh,0000,9200h,008fh
;                    Ŀ       Hi: Base 31:24  
; Limite 15:0                Low: G,DB,0,AVL,Lim 19:16
; Base 15:0              
; Hi= P,DPL(2),S,Type(4)  Low: Base 23:16

gdt_struct dw 15   ;limite GDT
           dd ?    ;base GDT (adresse linaire)
                   ;TOTAL = 6 bytes

v86 db 'Processeur en mode V86! Reboote sans ''EMM386'' ou ''QEMM''',10,13
    db 'NOTE: ''HIMEM.SYS'' doit tre prsent.$'
no_xms db 'Hey mec! Reviens quand tu auras ''HIMEM.SYS'' dans ton '
       db '''CONFIG.SYS''',10,13,'$'
no_more_xms db 'Oh nooo! Pas assez de mmoire XMS disponible!',10,13,'$'

xms_addy dd ?	;Adresse du gestionnaire XMS dans la mmoire
chunk_addy dd ? ;adr. du gros bloc XMS allou
handle_emb dw 0
messy db "Mode FLAT initialis. Appuyez sur ESC"
messy_length equ $-messy

pile dd 64 dup('ELIP')

code ends
end
